package org.nakedobjects.nos.webapp;

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.URLDecoder;
import java.util.Date;
import java.util.Iterator;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.nakedobjects.noa.security.Session;
import org.nakedobjects.nof.boot.system.Monitor;
import org.nakedobjects.nof.boot.system.NakedObjectsSystem;
import org.nakedobjects.nos.client.web.servlet.SystemAccess;


public class MonitorServlet extends HttpServlet {
    private static final long serialVersionUID = 1L;
    private Monitor monitor;

    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String queryString = request.getQueryString();
        String query = queryString == null ? "Overview" : URLDecoder.decode(queryString);
        response.setContentType("text/html");
        PrintWriter writer = new PrintWriter(new OutputStreamWriter(response.getOutputStream()));
        if (query.equals("Sessions")) {
            writer.println("<HTML><HEAD><TITLE>NOF System Monitor - " + "Sessions" + "</TITLE></HEAD>");
            writer.println("<BODY>");

            writer.println("<h1>" + "Sessions" + "</h1>");
            writer.println("<pre>");
            writer.println(listSessions());
            writer.println("</pre>");
            writer.println("</BODY></HTML>");
        } else {
            monitor.writePage(query, writer);
        }
        writer.flush();
    }

    private static String listSessions() {
        StringBuffer str = new StringBuffer();
        Iterator it = SystemAccess.getSessions().iterator();
        while (it.hasNext()) {
            HttpSession session = (HttpSession) it.next();
            String id = session.getId();
            str.append(id);
            str.append(" \t");

            long creationTime = session.getCreationTime();
            str.append(new Date(creationTime));
            str.append(" \t");

            long lastAccessedTime = session.getLastAccessedTime();
            str.append(new Date(lastAccessedTime));
            str.append(" \t");

            Session nofSession = (Session) session.getAttribute("NOF_SESSION_ATTRIBUTE");
            if (nofSession != null) {
                str.append(nofSession.getUserName());
            }

            str.append("\n");
        }
        return str.toString();
    }

    public void init(ServletConfig arg0) throws ServletException {
        super.init(arg0);
        monitor = new Monitor();
        monitor.setTarget((NakedObjectsSystem) SystemAccess.getManager());
    }
}

// Copyright (c) Naked Objects Group Ltd.
